
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title UBFX

@desc Unsigned Bit Field Extract extracts any number of adjacent bits at any position from a register, zero-extends them to 32 bits, and writes the result to the destination register.

@encoding (T1) {

	@word 1 1 1 1 0 0 1 1 1 1 0 0 Rn(4) 0 imm3(3) Rd(4) imm2(2) 0 widthm1(5)

	@syntax <reg_D> <reg_N> <lsbit> <width>

	@conv {

		reg_D = Register(Rd)
		reg_N = Register(Rn)
		lsbit = UInt(imm3:imm2)
		width = IncWidth(widthm1)

	}

}

@encoding (A1) {

	@word cond(4) 0 1 1 1 1 1 1 widthm1(5) Rd(4) lsb(5) 1 0 1 Rn(4)

	@syntax <reg_D> <reg_N> <lsbit> <width>

	@conv {

		reg_D = Register(Rd)
		reg_N = Register(Rn)
		lsbit = UInt(lsb)
		width = IncWidth(widthm1)

	}

	@rules {

		chk_call StoreCondition(cond)

	}

}

