
/* Chrysalide - Outil d'analyse de fichiers binaires
 * processor.h - prototypes pour la gestion de l'architecture mips
 *
 * Copyright (C) 2009-2017 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_MIPS_PROCESSOR_H
#define _ARCH_MIPS_PROCESSOR_H


#include "../processor.h"



#define G_TYPE_MIPS_PROCESSOR                g_mips_processor_get_type()
#define G_MIPS_PROCESSOR(obj)                (G_TYPE_CHECK_INSTANCE_CAST((obj), g_mips_processor_get_type(), GMipsProcessor))
#define G_IS_MIPS_PROCESSOR(obj)             (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_mips_processor_get_type()))
#define G_MIPS_PROCESSOR_GET_IFACE(inst)     (G_TYPE_INSTANCE_GET_INTERFACE((inst), g_mips_processor_get_type(), GMipsProcessorIface))


/* Définition du processeur de la mips (instance) */
typedef struct _GMipsProcessor GMipsProcessor;

/* Définition du processeur de la mips (classe) */
typedef struct _GMipsProcessorClass GMipsProcessorClass;


/* Indique le type défini par la GLib pour le processeur mips. */
GType g_mips_processor_get_type(void);

/* Crée le support de l'architecture mips. */
GArchProcessor *g_mips_processor_new(void);



#endif  /* _ARCH_MIPS_PROCESSOR_H */
